<template>
  <div>
    <v-row justify="center">
      <v-col cols="12" md="2">
        <v-menu v-model="menuStart" :close-on-content-click="false" offset-y>
          <template v-slot:activator="{ on, attrs }">
            <v-text-field
              v-model="dateStartFormatted"
              label="Fecha de inicio"
              append-icon="mdi-calendar"
              readonly
              @blur="dateStart = parseDate(dateStartFormatted)"
              v-bind="attrs"
              v-on="on"
            ></v-text-field>
          </template>
          <v-date-picker
            color="primary"
            v-model="dateStart"
            @input="menuStart = false"
          />
        </v-menu>
      </v-col>
      <v-col cols="12" md="2">
        <v-menu v-model="menuEnd" :close-on-content-click="false" offset-y>
          <template v-slot:activator="{ on, attrs }">
            <v-text-field
              v-model="dateEndFormatted"
              label="Fecha de fin"
              append-icon="mdi-calendar"
              readonly
              @blur="dateEnd = parseDate(dateEndFormatted)"
              v-bind="attrs"
              v-on="on"
            ></v-text-field>
          </template>
          <v-date-picker
            color="primary"
            v-model="dateEnd"
            @input="menuEnd = false"
          />
        </v-menu>
      </v-col>
      <v-col cols="12" md="2">
        <v-autocomplete
          v-model="idNegocio"
          :items="negocios"
          :loading="isLoadingNegocios"
          flat
          label="Negocio"
          item-text="descripcion"
          item-value="idNegocio"
          clearable
        />
      </v-col>
      <v-col cols="12" md="2">
        <v-autocomplete
          v-model="nivelCentroCostos"
          :items="nivelesGeograficos"
          :loading="isLoadingNivelesGeograficos"
          flat
          label="Geografía"
          item-text="descripcion"
          item-value="centroCostos"
          clearable
        />
      </v-col>
      <v-col md="2" class="d-flex align-center">
        <v-btn
          bottom
          block
          color="primary"
          @click="setFiltros"
          :disabled="validSearch"
          >Consultar</v-btn
        >
      </v-col>
    </v-row>
  </div>
</template>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
var now = new Date();
var quarter = Math.floor(now.getMonth() / 3);
var firstDate = new Date(now.getFullYear(), quarter * 3, 1);
var secondDate = new Date(firstDate.getFullYear(), firstDate.getMonth() + 3, 0);
let dateStart = firstDate.toISOString().substr(0, 10);
let dateEnd = secondDate.toISOString().substr(0, 10);
export default {
  name: "Component-Filtros",
  props: {
    value: {
      required: true,
    },
    disciplina: {
      required: true,
    },
  },
  data() {
    return {
      isLoadingNegocios: false,
      isLoadingNivelesGeograficos: false,
      localValue: this.value,
      menuStart: false,
      dateStartFormatted: this.formatDate(dateStart),
      dateStart: dateStart,
      menuEnd: false,
      dateEndFormatted: this.formatDate(dateEnd),
      dateEnd: dateEnd,
      negocios: [],
      idNegocio: null,
      nivelesGeograficos: [],
      nivelCentroCostos: null,
      counter: 0,
    };
  },
  watch: {
    localValue(newValue) {
      this.$emit("input", newValue);
    },
    value(newValue) {
      if (newValue && newValue.request.fechaInicio) {
        this.dateStart = this.parseDate(newValue.request.fechaInicio);
      }
      if (newValue && newValue.request.fechaFin) {
        this.dateEnd = this.parseDate(newValue.request.fechaFin);
      }
      this.idNegocio = newValue.request.idNegocio;
      this.nivelCentroCostos = newValue.request.nivelCentroCostos;
      this.localValue = newValue;
    },
    dateStart(val) {
      this.dateStartFormatted = this.formatDate(this.dateStart);
      this.getNivelesGeograficos();
    },
    dateEnd(val) {
      this.dateEndFormatted = this.formatDate(this.dateEnd);
      this.getNivelesGeograficos();
    },
    validSearch(value) {
      if (!value && this.counter == 0) {
        this.setFiltros();
        this.counter++;
      }
    },
  },
  computed: {
    validSearch() {
      return !(
        this.dateStartFormatted &&
        this.dateEndFormatted &&
        this.idNegocio != null
      );
    },
  },
  methods: {
    setFiltrosExternal(data) {
      this.nivelCentroCostos = data.request.nivelCentroCostos;
      this.setFiltros();
    },
    setFiltros() {
      this.localValue = {
        path: {
          idDisciplina: this.disciplina.idDisciplina,
        },
        request: {
          fechaInicio: this.dateStartFormatted,
          fechaFin: this.dateEndFormatted,
          idNegocio: this.idNegocio,
          nivelCentroCostos: this.nivelCentroCostos,
        },
      };
    },
    formatDate(date) {
      if (!date) return null;
      const [year, month, day] = date.split("-");
      return `${day}/${month}/${year}`;
    },
    parseDate(date) {
      if (!date) return null;
      const [day, month, year] = date.split("/");
      return `${year}-${month.padStart(2, "0")}-${day.padStart(2, "0")}`;
    },
    getNegocios() {
      this.isLoadingNegocios = true;
      axios(
        "/sistema-informacion/tablero/reportes/v1/disciplinas/" +
          this.disciplina.idDisciplina +
          "/filtros/negocios/busquedas"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.negocios = data.resultado.negocios;
            if (this.negocios.length > 0) {
              this.idNegocio = this.negocios[0].idNegocio;
            }
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.negocios = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.isLoadingNegocios = false;
        });
    },
    getNivelesGeograficos(init) {
      this.isLoadingNivelesGeograficos = true;
      let body = {
        fechaInicio: this.dateStartFormatted,
        fechaFin: this.dateEndFormatted,
      };
      if (init) {
        body = {};
      }
      axios
        .post(
          "/sistema-informacion/tablero/reportes/v1/disciplinas/" +
            this.disciplina.idDisciplina +
            "/filtros/geografia/busquedas",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.nivelesGeograficos = data.resultado.nivelesGeograficos;
            if (this.nivelesGeograficos.length > 0) {
              this.nivelCentroCostos = this.nivelesGeograficos[0].centroCostos;
            }
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.nivelesGeograficos = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.isLoadingNivelesGeograficos = false;
        });
    },
  },
  created() {
    this.getNegocios();
    this.getNivelesGeograficos(true);
  },
};
</script>
